<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
defined('_JEXEC') or die;

class PayperfileMail
{
	public function send($row, $email, $html='', $file=FALSE)
	{
		$mailer = JFactory::getMailer();
		$jAp = JFactory::getApplication();
		
		$lsFromEmail = $jAp->getCfg('mailfrom');
		$lsFromName  = $jAp->getCfg('fromname');
		$lsFrom 	 = array($lsFromEmail, $lsFromName);
		
		$mailer->addRecipient($email);
		$mailer->setSender($lsFrom);
		$mailer->addReplyTo($lsFrom);
		$mailer->setSubject(JText::_('PPF_MES').' '.$_SERVER['HTTP_HOST']);
		$mailer->setBody($html);
		$mailer->isHTML(true);
		
		$path =JPATH_ADMINISTRATOR.DS.'components'.DS.'com_payperfile'.DS.'data'.DS.$row->folder.DS.$row->filename;
		if($file&&file_exists($path)&&$row->filename){
			$mailer->addAttachment($path);
		}
		
		$mailer->Send();
	}
}
