<?php
/**
* @Copyright ((c) bigemot.ru
* @ http://bigemot.ru/
* @license    GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

$app = JFactory::getApplication();
$jinput = $app->input;

// если не наш мерчант, вернемся в функциональный модуль. (обращение через компонент, не плагин)
if($option=='com_payperfile'&&$jinput->get('result')!='ps_interkassa2') return;

$psParams = json_decode($ps->params, TRUE); // получим параметры платежной системы

require_once JPATH_ADMINISTRATOR.'/components/com_payperfile/helpers/payperfile.php';
require_once JPATH_ADMINISTRATOR.'/components/com_payperfile/helpers/currency.php';
$ppfCurrency = $ppfSes = new ppfCurrency;
$price = $ppfCurrency->GetPrice( $row->price, $row->currency, $psParams['curr'] );
if(!$price) JError::raiseWarning('', $psParams['curr'] .' '.JText::_('not found'));
$price *=(1 + (0.01*$ps->rate));
$price = round($price,2);

if(
	!$jinput->get( 'ik_sign', FALSE ) || $option!='com_payperfile'
	)
	{
		if($price)
		{
			if($jinput->get('prereq')!='pre')
			{
				$html .='<tr>';
				$html .= '<td>'.$ps->title.'</td>';
				$html .= '<td width="1%" nowrap="nowrap" align="right">'.$ppfCurrency->formatPrice($price, $fmParams['format']).'</td>';
				$html .= '<td width="1%">'.$psParams['curr'].'</td>';
				$html .= '<td width="1%">';
				
				$url = JURI::getInstance();
				$cache =  JFactory::getCache();
				if($cache->getCaching()){
					$url ->setVar('cache',rand());
				}
				$surl= $url ->toString();
				$url ->setVar('ppf2','error');
				$fail= $url ->toString();
				
				
				$action='/index.php?option=com_payperfile&format=raw&result=ps_interkassa2&prereq=pre&ik_x_id='.$id;
		
				$html .= "<form class=\"payperfile\" action=\"".$action."\" method=\"POST\" >";
				$html .= "<input type=\"hidden\" name=\"ppf_email\" value=\"\">";
				$html .= "<input type=\"hidden\" name=\"psid\" value=\"".$ps->id."\">";
				$html .= "<input type=\"hidden\" name=\"result_url\" value=\"".$surl."\">";
				$html .= "<input type=\"hidden\" name=\"fail_url\" value=\"".$fail."\">";
				$html .= "<input type=\"button\" value=\"".$fmParams['btn1']."\" onclick=\"ppfWin(this.form,".(int)$fmParams['target'].")\" class=\"ppf_btn\"/>";
				$html .= "</form>";
				$html .='</td></tr>';
			}
			else{
				if($ps->id!=$jinput->getInt('psid')) return;
			
				$ppf_email= $jinput->getVar( 'ppf_email', '' );
				$ppf_user = "*".$user->get('id');
				$ses = "*".md5($session->getID());
				$ik_baggage_fields=$ppf_email.$ppf_user.$ses;

				$ik_shop_id = $psParams['purse'];
				
				$action='https://sci.interkassa.com/';
				
				$html  = "<form name=\"payperfile\" action=\"".$action."\" method=\"POST\" accept-charset=\"UTF-8\">";
				$html .= "<input type=\"hidden\" name=\"ik_co_id\" value=\"".$ik_shop_id."\">";
				$html .= "<input type=\"hidden\" name=\"ik_pm_no\" value=\"".time()."\">";
				$html .= "<input type=\"hidden\" name=\"ik_am\" value=\"".$price."\">";
				$html .= "<input type=\"hidden\" name=\"ik_desc\" value=\"".$fmParams['desc']."\">";
				$html .= "<input type=\"hidden\" name=\"ik_fal_u\" value=\"".$_POST['fail_url']."\">";
				$html .= "<input type=\"hidden\" name=\"ik_suc_u\" value=\"".$_POST['result_url']."\">";
				$html .= "<input type=\"hidden\" name=\"ik_x_f1\" value=\"".$ik_baggage_fields."\">";
				$html .= "<input type=\"hidden\" name=\"ik_x_id\" value=\"".$id."\">";
				$html .= "</form>";
				$html .= "<script type=\"text/javascript\">document.forms.payperfile.submit();</script>";
				echo $html;
				die();
		}
	}
} 
elseif($jinput->getVar( 'ik_inv_st', FALSE)=='success')
{
	if($jinput->getVar('mod','')=='res'){
	
		if($price!==round($_POST["ik_am"],2))return;
		if(trim($psParams['purse'])!==trim($_POST['ik_co_id']))return;
		
		$dataSet=$_POST;
		unset($dataSet['ik_sign']);
		ksort($dataSet, SORT_STRING);
		array_push($dataSet, PayperfileHelper::encode(base64_decode($psParams['secret_key'])));
		$signString = implode(':', $dataSet); 
		$sign = base64_encode(md5($signString, true)); 
		
	  if(strtoupper($sign)!==strtoupper($_POST["ik_sign"])){
			header("HTTP/1.0 404 Not Found");
			header('Location: error404');
			exit;
	  }
	
		$registry = new JRegistry();
		$registry->loadArray($_REQUEST);
		$ss=explode('*', $_REQUEST['ik_x_f1']);
		$mail = $ss[0];
		$ppf_user = $ss[1];
		$ses = $ppfSes->getChen($ss[2]);
	  $registry->set('ppf_email',$mail);
	  
		$ss3 = (bool)preg_match("/[0-9a-f]{32}/i", $ss[2]);
		if(!$ss3) return;
		
		$fields = array(
			'session_id' => $ses, 
			'date' => time(),
			'user' => (int)$ppf_user, 
			'currency' => $psParams['curr'], 
			'amount' => $price,
			'params' => $registry->toString(), 
			'ps' => $ps->title, 
			'fm' => $row->fm, 
			'fileid' => (int)$id
		);
			
		$v_key=	$v_value='';
		foreach($fields as $key=>$value){
			$v_key.=",$key";
			$v_value.=",'$value'";
		}
		$v_key=substr($v_key, 1);
		$v_value=substr($v_value, 1);

		$db->setQuery("INSERT INTO `#__payperfile_stat` ($v_key) VALUES ($v_value)");
		$db->query();
		
		$db->setQuery("UPDATE `#__payperfile` SET hits = ( hits + 1 ) WHERE id = ".(int)$id);
		$db->query();
		
		if($maySend && $ses && $mail) {
			require_once JPATH_ADMINISTRATOR.'/components/com_payperfile/helpers/ppf_email.php';
			$ppf_email = new PayperfileMail;
			$ppf_email->send($row, $mail, $mailhtml, $attachment);
		}

		echo "200 OK";
		die();
	}
	
}