<?php
/**
* @Copyright ((c) bigemot.ru
* @ http://bigemot.ru/
* @license    GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

$app = JFactory::getApplication();
$jinput = $app->input;

// если не наш мерчант, вернемся в функциональный модуль. (обращение через компонент, не плагин)
if($option=='com_payperfile'&&$jinput->get('result')!='ps_robox') return;

$psParams = json_decode($ps->params, TRUE); // получим параметры платежной системы

require_once JPATH_ADMINISTRATOR.'/components/com_payperfile/helpers/payperfile.php';
require_once JPATH_ADMINISTRATOR.'/components/com_payperfile/helpers/currency.php';
$ppfCurrency = $ppfSes = new ppfCurrency;
$price = $ppfCurrency->GetPrice( $row->price, $row->currency, $psParams['curr'] );
if(!$price) JError::raiseWarning('', $psParams['curr'] .' '.JText::_('not found'));
$price *=(1 + (0.01*$ps->rate));
$price = round($price,2);

if(
	!$jinput->get( 'InvId', NULL ) || $option!='com_payperfile'
	)
	{
		if($price)
		{
			if($jinput->get('prereq')!='pre')
			{
				$html .='<tr>';
				$html .= '<td>'.$ps->title.'</td>';
				$html .= '<td width="1%" nowrap="nowrap" align="right">'.$ppfCurrency->formatPrice($price, $fmParams['format']).'</td>';
				$html .= '<td width="1%">'.$psParams['curr'].'</td>';
				$html .= '<td width="1%">';
				
				$url = JURI::getInstance();
				$cache =  JFactory::getCache();
				if($cache->getCaching()){
					$url ->setVar('cache',rand());
				}
				$shpa=UrlEncode($url ->toString());
				
				$action='/index.php?option=com_payperfile&format=raw&result=ps_robox&prereq=pre&shpc='.$id;
		
				$html .= "<form class=\"payperfile\" action=\"".$action."\" method=\"POST\" >";
				$html .= "<input type=\"hidden\" name=\"ppf_email\" value=\"\">";
				$html .= "<input type=\"hidden\" name=\"psid\" value=\"".$ps->id."\">";
				$html .= "<input type=\"hidden\" name=\"result_url\" value=\"".$shpa."\">";
				$html .= "<input type=\"button\" value=\"".$fmParams['btn1']."\" onclick=\"ppfWin(this.form,".(int)$fmParams['target'].")\" class=\"ppf_btn\"/>";
				$html .= "</form>";
				$html .='</td></tr>';
			}
			else{
				if($ps->id!=$jinput->getInt('psid')) return;
			
				$ppf_email= $jinput->getVar( 'ppf_email', '' );
				$ppf_user = "*".$user->get('id');
				$ses = "*".md5($session->getID());

				$mrh_login = $psParams['purse'];
				$mrh_pass1 = PayperfileHelper::encode(base64_decode($psParams['secret_key1']));
				$out_summ = $price;
				$inv_id = 0;
				$inv_desc = $fmParams['desc'];
				$shpa=$_POST['result_url'];
				$shpb=$ppf_email.$ppf_user.$ses;
				$shpc=$id;
				$crc  = md5("$mrh_login:$out_summ:$inv_id:$mrh_pass1:shpa=$shpa:shpb=$shpb:shpc=$shpc");
		
				$action='https://merchant.roboxchange.com/Index.aspx';
				if(!$psParams['test']) $action='http://test.robokassa.ru/Index.aspx';
		
				$html  = "<form name=\"payperfile\" action=\"".$action."\" method=\"POST\" >";
				$html .= "<input type=\"hidden\" name=\"MrchLogin\" value=\"".$mrh_login."\">";
				$html .= "<input type=\"hidden\" name=\"OutSum\" value=\"".$out_summ."\">";
				$html .= "<input type=\"hidden\" name=\"InvId\" value=\"".$inv_id."\">";
				$html .= "<input type=\"hidden\" name=\"Desc\" value=\"".$inv_desc."\">";
				$html .= "<input type=\"hidden\" name=\"SignatureValue\" value=\"".$crc."\">";
//				$html .= "<input type=\"hidden\" name=\"IncCurrLabel\" value=\"".$in_curr."\">";
//				$html .= "<input type=\"hidden\" name=\"Culture\" value=\"".$culture."\">";
				$html .= "<input type=\"hidden\" name=\"shpa\" value=\"".$shpa."\">";
				$html .= "<input type=\"hidden\" name=\"shpb\" value=\"".$shpb."\">";
				$html .= "<input type=\"hidden\" name=\"shpc\" value=\"".$shpc."\">";
				$html .= "</form>";
				$html .= "<script type=\"text/javascript\">document.forms.payperfile.submit();</script>";
				echo $html;
				die();
		}
	}
} 
elseif($jinput->getVar( 'OutSum', FALSE))
{
	if($jinput->getVar('mod','')=='res'){
	
		if($price!=round($_REQUEST["OutSum"],2)) return;
	
	  $common_string = $_REQUEST["OutSum"].':'.$_REQUEST["InvId"].':'.PayperfileHelper::encode(base64_decode($psParams['secret_key2'])).':shpa='.$_REQUEST["shpa"].':shpb='.$_REQUEST["shpb"].':shpc='.$_REQUEST["shpc"];
	  if(strtoupper(md5($common_string))!==strtoupper($_REQUEST["SignatureValue"])) return;
	  
		$registry = new JRegistry();
		$registry->loadArray($_POST);
		$ss=explode('*', $_POST['shpb']);
		$mail = $ss[0];
		$ppf_user = $ss[1];
		$ses = $ppfSes->getChen($ss[2]);
	  $registry->set('ppf_email',$mail);
	  
		$ss3 = (bool)preg_match("/[0-9a-f]{32}/i", $ss[2]);
		if(!$ss3) return;
		
		$fields = array(
			'session_id' => $ses, 
			'date' => time(),
			'user' => (int)$ppf_user, 
			'currency' => $psParams['curr'], 
			'amount' => $price,
			'params' => $registry->toString(), 
			'ps' => $ps->title, 
			'fm' => $row->fm, 
			'fileid' => (int)$id
		);
			
		$v_key=	$v_value='';
		foreach($fields as $key=>$value){
			$v_key.=",$key";
			$v_value.=",'$value'";
		}
		$v_key=substr($v_key, 1);
		$v_value=substr($v_value, 1);

		$db->setQuery("INSERT INTO `#__payperfile_stat` ($v_key) VALUES ($v_value)");
		$db->query();
		
		$db->setQuery("UPDATE `#__payperfile` SET hits = ( hits + 1 ) WHERE id = ".(int)$id);
		$db->query();
		
		if($maySend && $ses && $mail) {
			require_once JPATH_ADMINISTRATOR.'/components/com_payperfile/helpers/ppf_email.php';
			$ppf_email = new PayperfileMail;
			$ppf_email->send($row, $mail, $mailhtml, $attachment);
		}
	
		 echo "OK".$_REQUEST["InvId"];	
		 die();
	}
	
	if($jinput->getVar('mod','')=='suc'){
		  $app->redirect(UrlDecode($_REQUEST["shpa"]), '');
	}
	
	if($jinput->getVar('mod','')=='fail'){
		$msg  = "An unexpected error occurred";
		  $app->redirect(UrlDecode($_REQUEST["shpa"]), $msg);
	}
}