<?php
/**
* @Copyright ((c) bigemot.ru
* @ http://bigemot.ru/
* @license    GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

$app = JFactory::getApplication();
$jinput = $app->input;

// если не наш мерчант, вернемся в функциональный модуль. (обращение через компонент, не плагин)
if($option=='com_payperfile'&&$jinput->get('result')!='ps_yd') return;

$psParams = json_decode($ps->params, TRUE); // получим параметры платежной системы

require_once JPATH_ADMINISTRATOR.'/components/com_payperfile/helpers/payperfile.php';
require_once JPATH_ADMINISTRATOR.'/components/com_payperfile/helpers/currency.php';
$ppfCurrency = $ppfSes = new ppfCurrency;
$price = $ppfCurrency->GetPrice( $row->price, $row->currency, 'RUB' );
$price *=(1 + (0.01*$ps->rate));
$price = round($price,2);

if(
	!$jinput->get('sha1_hash','') || $option!='com_payperfile'
	)
	{
		if($price)
		{
			if($jinput->get('prereq')!='pre')
			{
				
				// запишем в сессию пользователя адрес редиректа после оплаты. К сожалению ЯД не предоставляет такой параметр, поэтому так.
				$url = JURI::getInstance();
				$cache =  JFactory::getCache();
				if($cache->getCaching()){
					$url ->setVar('cache',rand()); // обход кэширования, если включено
				}
				$session->set('ppf_yd_redir',UrlEncode($url ->toString()));
				
				$html .='<tr>';
				$html .= '<td align="center">'.$ps->title.'</td>';
				$html .= '<td width="1%" nowrap="nowrap" align="right">'.$ppfCurrency->formatPrice($price, $fmParams['format']).'</td>';
				$html .= '<td width="1%">RUB</td>';
				$html .= '<td width="1%">';
				
				// т.к. мы не можем передать на сервер ЯД собственные параметры, используем предварительную форму, а после отправки пользователем своих данных, мы их склеим в переменную $label.

				$action='/index.php?option=com_payperfile&format=raw&result=ps_yd&prereq=pre&label='.$id;

				$html .= "<form class=\"payperfile\" action=\"".$action."\" method=\"POST\" >";
				$html .= "<input type=\"hidden\" name=\"ppf_email\" value=\"\">";
				if($ppfVar) $html .= "<input type=\"hidden\" name=\"ppf_var\" value=\"\">";
				$html .= "<input type=\"hidden\" name=\"psid\" value=\"".$ps->id."\">"; 
				$html .= "<input type=\"button\" value=\"".JText::_($fmParams['btn1'])."\" onclick=\"ppfWin(this.form,".(int)$fmParams['target'].")\" class=\"ppf_btn\"/>";
				$html .= "</form>";
				$html .='</td></tr>';
			}
			else{
				
				if(!$jinput->getInt('psid')){
					// именно сюда Яндекс вернет покупателя после оплаты. Сделаем редирект на страницу товара
					$ppf_yd_redir = $session->get('ppf_yd_redir');
					$app->redirect(UrlDecode($ppf_yd_redir), ''); // можно сообщение добавить
				}
				
				// поскольку в кнопке может находиться несколько экземпляров этого мерчанта, проверим, что это искомая платежная система. В противном случае вернем процесс в функциональный модуль.
				if($ps->id!=$jinput->getInt('psid')) return;
				
				// склеим в переменную $label данные, которые необходимо передать через сервер ЯД. К сожалению, длина этой переменной всего 64 знака, поэтому много передать мы не сможем.
				$ppf_email="*".$jinput->getVar('ppf_email','');  // email пользователя, на который будет отправлен товар.
				$ppf_user = "*".$user->get('id');  // id пользователя, если он авторизован. Этот параметр можно будет использовать для функций биллинга
				$ses = "*".md5($session->getID()); //хеш от id сессии пользователя. Именно этому пользователю будет потом показан товар на странице сайта.
				
				$label = $id.$ppf_email.$ppf_user.$ses.'*'.$ps->id;
				
				// поскольку длина  $label ограничена 64 символами, из которых переменная $ses занимает 32, то иногда мы не можем передать через нее все необходимые данные. Например я использую переменную $ppfVar, через которую передаю дополнительную информацию. Например при активации этого компонента на моем сайте, передается имя домена, который нужно активировать. В этом случае понадобится дополнительное хранилище информации. Конечно, можно подключить библиотеку Yandex.Money API SDK и запрашивать через нее, но практика показала, что лучше ее не использовать. Кроме того лишние запросы на сервер ЯД никому не нужны. Поэтому, если ваш функциональный модуль использует переменную $ppfVar, мы запишем ее в собственное хранилище. Базу данных использовать не будем, нет смысла из-за одного мерчанта и частного случая переписывать всю структуру компонента.
				
				if($ppfVar){
					$handle = fopen(__DIR__ . '/ppfvar/'.md5($session->getID()).'.txt', "w");
					$test = fwrite($handle, $jinput->get( 'ppf_var', '' ));
					if (!$test) $app->redirect(UrlDecode($session->get('ppf_yd_redir')), 'Error');
					fclose($handle);
					// сделаем автоматическую чистку папки от незавершенных транзакций. Я делаю интервал 7 дней, чтобы иногда смотреть активность пользователей, но достаточно делать 24 часа или еще меньше.
					jimport('joomla.filesystem.folder');
					$files = JFolder::files(__DIR__ . '/ppfvar');
					foreach($files as $file ){
						$time_file=filemtime(__DIR__ . '/ppfvar/' . $file);
						if(time() - $time_file >60*60*24*7) unlink(__DIR__ . '/ppfvar/' . $file);
					}
				}
				
				// составим форму со всеми нужными данными и сразу отправим ее на сервер ЯД с помощью javascript.

				$action='https://money.yandex.ru/quickpay/confirm.xml';
				
				$html  = "<form name=\"payperfile\" action=\"".$action."\" method=\"POST\" >";
				$html .= "<input type=\"hidden\" name=\"receiver\" value=\"".$psParams['purse']."\">";
				$html .= "<input type=\"hidden\" name=\"short-dest\" value=\"".$fmParams['desc']."\">";
				$html .= "<input type=\"hidden\" name=\"writable-targets\" value=\"false\">";
				$html .= "<input type=\"hidden\" name=\"quickpay-form\" value=\"shop\">";
				$html .= "<input type=\"hidden\" name=\"targets\" value=\"".$fmParams['desc'].' '.$jinput->get( 'ppf_var', '' )."\">";
				$html .= "<input type=\"hidden\" name=\"sum\" value=\"".round($price,$fmParams['format']?2:0)."\" data-type=\"number\" >";
				$html .= "<input type=\"hidden\" name=\"label\" value=\"".$label."\">";
				$html .= "</form>";
				$html .= "<script type=\"text/javascript\">document.forms.payperfile.submit();</script>";
				echo $html;
				die();
		}
	}
} 
elseif($jinput->get( 'sha1_hash', '' ))	{ // обработаем ответ сервера ЯД
	
	$ss=explode('*', $_POST['label']);
	if($ss[4]!=$ps->id) return; // это не та платежная система (случай, если вы создали несколько ПС с этим мерчантом), вернемся в функциональный модуль и найдем свою.
	
	$ss3 = (bool)preg_match("/[0-9a-f]{32}/i", $ss[3]);
	if(!$ss3) return; // при попытке фишинга нет смысла отдавать error, деньги все равно уже зачислены
	
	if($price!=$_POST['withdraw_amount']) return; //если цена товара не соответствует перечисленной, вернем false
	if($_POST['currency']!='643') return; //если валюта товара не соответствует RUB, вернем false
	
	// проверка, что это настоящий ответ сервера ЯД, не фишинг
		 $common_string = $_POST['notification_type'].'&'.$_POST['operation_id'].'&'.$_POST['amount'].'&'.$_POST['currency'].'&'.$_POST['datetime'].'&'.$_POST['sender'].'&'.$_POST['codepro'].'&'.PayperfileHelper::encode(base64_decode($psParams['secret_key'])).'&'.$_POST['label'];
	  if(sha1($common_string)!==$_POST['sha1_hash']) return;
		
		// если все в порядке, запишем данные платежа в базу сайта.

		$registry = new JRegistry();
		$registry->loadArray($_POST);
		$mail = $ss[1];
		$ppf_user = (int)$ss[2];
		$ses = $ppfSes->getChen($ss[3]);
	  $registry->set('ppf_email',$mail);
		
		if($ppfVar){
			// получим дополнительные параметры, если используется
			$ppfVarfile_name = __DIR__ . '/ppfvar/'.$ses.'.txt';
			$content = trim(file_get_contents($ppfVarfile_name));
			if($content){
				 unlink($ppfVarfile_name);
			}
			$registry->set('ppf_var', $content);
			
			// обработка дополнительных параметров
			// **
			// **
		}
		
		$fields = array(
			'session_id' => $ses, 
			'date' => time(),
			'user' => $ppf_user, 
			'currency' => 'RUB', 
			'amount' => $price,
			'params' => $registry->toString(), 
			'ps' => $ps->title, 
			'fm' => $row->fm, 
			'fileid' => (int)$id
		);
		
		$v_key=	$v_value='';
		foreach($fields as $key=>$value){
			$v_key.=",$key";
			$v_value.=",'$value'";
		}
		$v_key=substr($v_key, 1);
		$v_value=substr($v_value, 1);

		$db->setQuery("INSERT INTO `#__payperfile_stat` ($v_key) VALUES ($v_value)");
		$db->query();
		
		$db->setQuery("UPDATE `#__payperfile` SET hits = ( hits + 1 ) WHERE id = ".(int)$id);
		$db->query();
		
		// отправим письмо, если нужно
		if($maySend && $ses && $mail) {
			require_once JPATH_ADMINISTRATOR.DS.'components'.DS.'com_payperfile'.DS.'helpers'.DS.'ppf_email.php';
			$ppf_email = new PayperfileMail;
			$ppf_email->send($row, $mail, $mailhtml, $attachment);
		}
	
	 echo "OK";	
	 die();
}
