<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
defined('_JEXEC') or die;

JHtml::addIncludePath(JPATH_COMPONENT.'/helpers/html');
JHtml::_('behavior.tooltip');
JHtml::_('behavior.multiselect');
JHtml::_('formbehavior.chosen', 'select');
JHtml::_('behavior.calendar');
require_once JPATH_ADMINISTRATOR.DS.'components'.DS.'com_payperfile'.DS.'helpers'.DS.'currency.php';
$ppfCurrency = new ppfCurrency;
$fileid=$this->gfileid?'&fileid='.$this->gfileid:'';

$document = JFactory::getDocument();
		$document->addStyleDeclaration('
			.charts{
				position: relative;
				margin: 20px 20px 20px 50px;
			}
			.calctable{
				width: 100%;
				background-color: #FFFFFB;
			}
			.calctable td{
				border: 1px solid #CCC;
			}
			#sales_charts div {
				background-color: #C6E6F4;
				opacity:0.7;
			}
			.topbar div{
				float: right;
				margin-right: 10px;
			}
			.topbar .btn{
				margin-right: 3px;
			}
		');
?>

<form action="<?php echo JRoute::_('index.php?option=com_payperfile&view=charts'); ?>" method="post" name="adminForm" id="adminForm">
  <?php if(!empty( $this->sidebar)) { ?>
  <div id="j-sidebar-container" class="span2"> <?php echo $this->sidebar; ?> </div>
  <div id="j-main-container" class="span10">
  <?php }else { 
  echo '<div id="j-main-container">';
   }?>
    <ul class="nav nav-tabs">
      <li> <a href="<?php echo JRoute::_('index.php?option=com_payperfile&view=statistics'.$fileid); ?>"><?php echo JText::_('PPF_V2_LIST');?></a> </li>
      <li class="active"> <a href="javascript:void(0)"><?php echo JText::_('PPF_V2_GS');?></a> </li>
    </ul>
    <div id="filter-bar" class="btn-toolbar">
      <div class="btn-group pull-right ppf_calendar">
        <button class="btn hasTooltip" type="submit" title="<?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?>"><i class="icon-search"></i></button>
        <button class="btn hasTooltip" type="button" title="<?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?>" onclick="document.id('filter_min').value='';document.id('filter_max').value='';this.form.submit();"><i class="icon-remove"></i></button>
      </div>
      <div class="btn-group pull-right ppf_calendar">
        <?php 
      echo JHTML::_('calendar', $this->escape($this->state->get('filter.min')), 'filter_min', 'filter_min', '%Y-%m-%d', array('class'=>'inputbox', 'size'=>'20',  'maxlength'=>'20')); 
      echo JHTML::_('calendar', $this->escape($this->state->get('filter.max')), 'filter_max', 'filter_max', '%Y-%m-%d', array('class'=>'inputbox', 'size'=>'20',  'maxlength'=>'20')); 
      ?>
      </div>
      <div class="btn-group pull-right ">
      <?php 
			$vallist = array(
				 array ( "value"=>"1", "text"=>JText::_('PPF_CHARTS_1_DAY')),
				 array ( "value"=>"3", "text"=>JText::_('PPF_CHARTS_3_DAY')),
				 array ( "value"=>"5", "text"=>JText::_('PPF_CHARTS_5_DAY')),
				 array ( "value"=>"7", "text"=>JText::_('PPF_CHARTS_7_DAY')),
				 array ( "value"=>"10", "text"=>JText::_('PPF_CHARTS_10_DAY')),
				 array ( "value"=>"ym", "text"=>JText::_('PPF_CHARTS_M')),
				 array ( "value"=>"qym", "text"=>JText::_('PPF_CHARTS_3_M')),
				 array ( "value"=>"y", "text"=>JText::_('PPF_CHARTS_Y')),
			 );
			echo JHTML::_('select.genericlist', $vallist, 'filter_val', 'class="middle" onchange="this.form.submit()"', 'value', 'text', $this->state->get('filter.val')); 
			?>
      </div>
      
    </div>
    <div class="clearfix"> </div>
    <input type="hidden" name="task" value="" />
    <input type="hidden" name="fileid" value="<?php echo $fileid; ?>" />
    <input type="hidden" name="filter_currency" value="<?php echo $this->state->get('filter.currency') ?>" />
    <?php echo JHTML::_( 'form.token' ); 
		
		if(empty($this->items)){
			echo JText::_('PPF_V2_NOT_DATA'); 
			$this->min=0;
		}
		else{
			$this->min=$this->items[0]->date;
		}

			$fs=$this->state->get('filter.val');
			$this->ntime=$this->state->get('filter.max')?strtotime($this->state->get('filter.max')):time();
			if($this->ntime>time())$this->ntime=time();
			
			
			$f=str_replace('q','',$fs);
			if(is_numeric($fs))$f='ymd';
			foreach ($this->items as $item){
				$d= date($f, $item->date);
				!isset($arr[$d])?$arr[$d]=0:'';
				$arr[$d]+=round($ppfCurrency->GetPrice( $item->amount, str_replace('RUR','RUB',$item->currency), $this->state->get('filter.currency') ),2);
			}
			$t=($f=='y')?364:28;
			if(is_numeric($fs))$t=1;
			$delta = 60*60*24*$t; 
			for($i =$this->min; $i < $this->ntime; $i+=$delta){
				!isset($arr[date($f,$i)])?$arr[date($f,$i)]=0:''; 
			}
			ksort($arr);
			if($fs=='qym'||(int)$fs){
				$n=(int)$fs?$fs:3;
				$i=0;
				foreach($arr as $k=>$v){
					if(!($i%$n))$d=$k;
					!isset($warr[$d])?$warr[$d]=0:'';
					$warr[$d]+=$v;
					$i++;
				}
				$arr= $warr;
			}

			foreach($arr as $k=>$v){
				$data[]= $k.':'.$v;
			}
			
			$len=sizeof($data);


			$tiks = $len<13?$len:13;


			$ntime = $this->ntime;
			$min = $this->min;
			if($this->state->get('filter.val')=='ym'){
				$ntime = strtotime(date('Y-m-30',$this->ntime));
				$min = strtotime(date('Y-m-01',$this->min));
			}
			$diapazon = $ntime - $min;
			
			$html ='<table width="100%" cellpadding="0" cellspacing="0"><tr>';
			
			if($this->state->get('filter.val')=='ym'&&($tiks == $len)){
				foreach($data as $i=>$row){
						if($i==0)$m=date('d M Y',$this->min);
						else $m=date('M Y',strtotime('20'.substr($row,0,2).'-'.substr($row,2,2).'-01'));
					$html .= '<td align="center" width="7%">'.$m.'</td>';
				}
			}
			elseif($this->state->get('filter.val')=='qym'){
				foreach($data as $i=>$row){
					$midle = strtotime('20'.substr($row,0,2).'-'.substr($row,2,2).'-15');
						if($i==0)$m=date('d M Y',$this->min).' - '.date('M',$midle+60*24*60*60);
						else $m=date('M',$midle).' - '.date('M',$midle+60*24*60*60);
					$html .= '<td align="center" width="7%">'.$m.'</td>';
				}
			}
			elseif($this->state->get('filter.val')=='y'){
				foreach($data as $i=>$row){
						if($i==0)$m=date('d M Y',$this->min);
						else $m=date('Y',strtotime('20'.substr($row,0,2).'-01-01'));
					$html .= '<td align="center" width="7%">'.$m.'</td>';
				}
			}
			else{
				$le=(int)($diapazon/($tiks?$tiks:1));
				$maxoo = is_numeric($this->state->get('filter.val'))?$this->ntime-$le:$this->ntime;
				for($i =$min; $i < $maxoo; $i+=$le){
					$html .= '<td width="7%">'.date('j M y', $i).'</td>';
				}
			}
			
			$html .= '</tr></table>';
			$xord= $html;
   
	 
	 
	  
			$html='';
			for($i =0; $i < 11; $i++){
				$html .= '<div style="height:40px">'.round(max($arr)-max($arr)*$i/10,0).
				'</div>';
			}
			$yord= $html;
		
			$html='<table class="calctable">';

			for($i =0; $i < 11; $i++){
				$html .= '<tr style="height:40px">';
				for($ii =0; $ii < $tiks; $ii++){
					$html .= '<td> </td>';
				}
				$html .= '</tr>';
			}
			$html .= '</table>';
			$abacus= $html;
		
		?> 
    <script type="text/javascript">
	var arr=[], resizeAverage=function() {
		var al=arr.length;if(al<10)return;
		var width=$('sales_charts').getWidth(), w=width /(al), svg='<svg xmlns="http:\/\/www.w3.org\/2000\/svg" version="1.1"  height = "440px"  width = "'+ width +'px"><polyline points="';
		for(var i=0;i<al;i++){
			if(al<20)var s=0,e=1,d=(arr[i-1]+arr[i]+arr[i+1])/3;
			else if(al<40)var s=1,e=2,d=(arr[i-2]+arr[i-1]+arr[i]+arr[i+1]+arr[i+2])/5;
			else var s=2,e=3,d=(arr[i-3]+arr[i-2]+arr[i-1]+arr[i]+arr[i+1]+arr[i+2]+arr[i+3])/7;
			if(s<i&&i<al-e)svg+=Math.round(w*i+w/2)+','+Math.round(d)+' ';
		}
		svg+='" style="fill:none;stroke:red;stroke-width:1" /></svg>';
		$('average').innerHTML=svg;
	};
  window.addEvents({
		'load': function() {
			var ppfDATA = <?php echo '{'.implode(',',$data).'}' ?>,phtml='',i=0;
			for (var key in ppfDATA) {
				var height=Math.round(ppfDATA[key]/<?php echo max($arr)/400 ?>);
				if(!height&&ppfDATA[key]>0)height=1;
				phtml+='<td><div style="height:'+height+'px;" title=" '+ppfDATA[key]+'\n('+key.slice(4)+' '+key.slice(2,4)+' 20'+key.slice(0,2)+')"></div></td>';
				arr[i]=440-height;
				i++;
			}
			$('sales_charts').innerHTML=phtml;
			resizeAverage();
		},
		'resize': resizeAverage
  });
			function chcurr(curr){
				document.forms.adminForm.filter_currency.value=curr;
				document.forms.adminForm.submit();
			}
    </script>
    <div align="right"><strong><?php echo $this->state->get('filter.currency') ?></strong>, <?php echo JText::_('PPF_V2_PRS'); ?> <a href="javascript:chcurr('USD')">USD</a> <a href="javascript:chcurr('RUB')">RUB</a> <a href="javascript:chcurr('EUR')">EUR</a></div>
<div style="clear:both"></div>
<div style="position:relative; border: 1px solid #CCC; height: 500px; margin: 20px 0px; background-color: #FAF8F8;">
  <div style="position:absolute; right:30px;"><?php //echo $this->lists['currencies'] ?></div>
  <div class="charts">
    <div style="position:absolute; width: 100%;"><?php echo $abacus; ?></div>
  </div>
  <div style="position:absolute; top:53px; width:45px; text-align:right; font-size:11px;"><?php echo $yord; ?></div>
  <div class="charts">
    <div style="position:absolute; width: 100%; height: 440px;">
      <div style="position:absolute;top:0" id="average"></div>
      <table width="100%" cellpadding="0" cellspacing="0" height="440">
        <tr id="sales_charts" valign="bottom"></tr>
      </table>
    </div>
  </div>
  <div class="charts">
    <div style="position: absolute; top: 450px; width: 100%; font-size: smaller;"><?php echo $xord; ?></div>
  </div>
</div>
  </div>
</form>
