<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
defined('_JEXEC') or die;

JHtml::addIncludePath(JPATH_COMPONENT.'/helpers/html');

$user		= JFactory::getUser();
$canDelete = $user->authorise( 'core.delete', 'com_payperfile');

if($del=JRequest::getVar('del', FALSE)){
	delFiles($del, $canDelete);
	$app	= JFactory::getApplication();
	$app->redirect('index.php?option=com_payperfile&view=folders');
}

?>
<div id="j-sidebar-container" class="span2"> <?php echo $this->sidebar; ?> </div>
<div id="j-main-container" class="span10">
<?php 

echo '<h3>'.JText::_( 'PPF_V1_T' ).'</h3>';
echo ($path=JPATH_ADMINISTRATOR.DS."components".DS."com_payperfile".DS."data").'/<br><br><br>';
echo (ls_recursive2($path, $canDelete));
				
function ls_recursive2($dir, $canDelete)  { 
   if (is_dir($dir)) { 
     $files = scandir($dir); 
     foreach ($files as $file) { 
       $currentfile = $dir . "/" . $file; 
       $last_dir = ""; 
       $count = substr_count($currentfile, '/'); 
       $minus_count = substr_count($_SERVER['DOCUMENT_ROOT'], '/'); 
       $count -= ($minus_count + 2); 
                 
       for($p = 0; $p < $count; $p++)  { 
         $last_dir .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"; 
       } 
                 
       if (is_dir($currentfile))  { 
         if ($file != '.' && $file != '..')  { 
         $last_dir .= "<span><img src='/administrator/components/com_payperfile/assets/images/folder.png'>&nbsp;<a href=\"javascript:void()\" onclick=\"tgldispl(this)\">". substr($currentfile, strrpos($currentfile, '/'))."</a> (".countFiles($currentfile).") ".delLink($currentfile, $canDelete)."<br>"; 
           echo $last_dir; 
					 echo "<span style=\"display:none\">";
							 ls_recursive2($currentfile, $canDelete); 
					 echo "</span></span>";
         } 
       } else { 
         $last_dir .= "<img src='/administrator/components/com_payperfile/assets/images/file.png'>&nbsp;<a target=\"_blank\" style=\"color:grey\" href=\"http://".$_SERVER['HTTP_HOST'].DS.'administrator'.str_replace(JPATH_BASE,'',$currentfile) ."\">". substr($currentfile, strrpos($currentfile, '/')) . "</a> ".delLink($currentfile, $canDelete)."<br>"; 
         echo $last_dir; 
       } 
     } 
   } 
 } 
 
function delLink($dir, $canDelete){ 
	$html='';
	if(!$canDelete)return $html;
	$dlink = 'index.php?option=com_payperfile&view=folders&del=';
	if (!is_dir($dir)&&file_exists($dir)) {
		$html="<em><a style=\"color:red; padding-left:10px;\" href=\"".$dlink.$dir."\">delete</a></em>";
		if(substr($dir, strrpos($dir, '/')+1)=='index.html')$html='';
	}
	else{
		$files = countFiles($dir);
		if (is_dir($dir)&&empty($files)){
			$html="<em><a style=\"color:red; padding-left:10px;\" href=\"".$dlink.$dir."\">delete</a></em>";
		}
	}
	 return $html; 
}
 
function countFiles($dir){ 
	$files = array(); 
	$directory = opendir($dir); 
	while($item = readdir($directory)){ 
	  if(($item != ".") && ($item != "..") && ($item != ".svn") ){ 
		   $files[] = $item; 
	  } 
	} 
	$numFiles = count($files); 
	return $numFiles; 
}
 
 
function delFiles($dir, $canDelete){ 
	if(!$canDelete) die;
	$dirstr=JPATH_ADMINISTRATOR.DS."components".DS."com_payperfile".DS."data";
	if(!substr_count($dir, $dirstr)||$dir==$dirstr||$dir==$dirstr.DS) return;
	if (!is_dir($dir)&&file_exists($dir)) {JFile::delete($dir);}
	else{
		$folder=JFolder::files($dir);
		if (is_dir($dir)&&empty($folder))JFolder::delete($dir);
	}
}


?>
</div>
<script language="JavaScript" type="text/javascript">
function tgldispl(x){
	x=x.getParent().getElement('span').style;
	x.display=(x.display=='none')?'':'none';
}
</script> 
