<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

JHtml::addIncludePath(JPATH_COMPONENT.'/helpers/html');
JHtml::_('behavior.tooltip');
JHtml::_('behavior.formvalidation');
JHtml::_('behavior.combobox');
JHtml::_('formbehavior.chosen', 'select');

?>
<script type="text/javascript">
	Joomla.submitbutton = function(task)
	{
		if (task == 'payperfile.cancel' || document.formvalidator.isValid(document.id('payperfile-form'))) {
			Joomla.submitform(task, document.getElementById('payperfile-form'));
		}
		else {
			alert('<?php echo $this->escape(JText::_('JGLOBAL_VALIDATION_FORM_FAILED'));?>');
		}
	}
</script>

<h3><?php echo JText::_($this->item->name) ?></h3>
<form action="<?php echo JRoute::_('index.php?option=com_payperfile&layout=edit&id='.(int) $this->item->id); ?>" method="post" name="adminForm" id="payperfile-form" class="form-validate" enctype="multipart/form-data">
  <div class="row-fluid">
    <div class="span10 form-horizontal">
      <ul class="nav nav-tabs">
        <li class="active"><a href="#details" data-toggle="tab"><?php echo empty($this->item->id) ? JText::_('COM_PAYPERFILE_NEW') : JText::sprintf('PPF_V3_EDIT', $this->item->id); ?></a></li>
        <li><a href="#publishing" data-toggle="tab"><?php echo JText::_('JGLOBAL_FIELDSET_PUBLISHING');?></a></li>
        <?php
			?>
        <li><a href="#params-params" data-toggle="tab"><?php echo JText::_('PPF_V3_PARAMS');?></a></li>
        <li><a href="#statistics" data-toggle="tab"><?php echo JText::_('PPF_V3_STAT');?></a></li>
      </ul>
      <div class="tab-content">
        <div class="tab-pane active" id="details">
          <div class="control-group">
            <div class="control-label"><?php echo $this->form->getLabel('title'); ?></div>
            <div class="controls"><?php echo $this->form->getInput('title'); ?></div>
          </div>
          <?php if ($this->item->showfile!='n'): ?>
          <div class="control-group">
            <div class="control-label"><label id="uploadfile-lbl" for="uploadfile" class="hasTip" title="Если у вас введено ниже название файла, то загружаемый файл будет переименован"><?php echo JText::_('JTOOLBAR_UPLOAD'); ?></label></div>
            <div class="controls">
              <input type="file" name="uploadfile">
              <div title="<?php echo JText::_('PPF_V3_LOAD'); ?>"><?php echo JText::_('PPF_V3_LOAD2'); ?>
                <input name="upd" type="checkbox" value="1" />
              </div>
            </div>
          </div>
          <?php endif;
				?>
          <?php if ($this->item->showprice!='n'): ?>
          <div class="control-group">
            <div class="control-label"><?php echo $this->form->getLabel('price'); ?></div>
            <div class="controls"><?php echo $this->form->getInput('price'); ?><?php echo $this->form->getInput('currency'); ?></div>
          </div>
          <?php endif;
				?>
          <?php if ($this->item->showfile!='n'): ?>
          <div class="control-group">
            <div class="control-label"><?php echo $this->form->getLabel('filename'); ?></div>
            <div class="controls"><?php echo $this->form->getInput('filename'); ?></div>
          </div>
          <input type="hidden" name="oldfilename" value="<?php echo $this->item->filename; ?>" />
          <?php endif;
				?>
          <?php if ($this->item->showfolder!='n'): ?>
          <div class="control-group">
            <div class="control-label"><?php echo $this->form->getLabel('folder'); ?></div>
            <div class="controls"><?php echo $this->loadTemplate('folder'); ?></div>
          </div>
          <input type="hidden" name="oldfolder" value="<?php echo $this->item->folder; ?>" />
          <?php endif;
				?>
          <div class="control-group">
            <div class="control-label"><?php echo $this->form->getLabel('catid'); ?></div>
            <div class="controls"><?php echo $this->form->getInput('catid'); ?></div>
          </div>
          <div class="control-group">
            <div class="control-label"><?php echo $this->form->getLabel('ordering'); ?></div>
            <div class="controls"><?php echo $this->form->getInput('ordering'); ?></div>
          </div>
          <?php if ($this->item->showmail!='n'): ?>
          <div class="control-group">
            <div class="control-label"><?php echo $this->form->getLabel('description'); ?></div>
            <div class="controls"><?php echo $this->form->getInput('description'); ?></div>
          </div>
          <?php endif;
				?>
        </div>
        <div class="tab-pane" id="publishing">
          <div class="control-group">
            <div class="control-label"><?php echo $this->form->getLabel('id'); ?></div>
            <div class="controls"><?php echo $this->form->getInput('id'); ?></div>
          </div>
          <div class="control-group">
            <div class="control-label"><?php echo $this->form->getLabel('date'); ?></div>
            <div class="controls"><?php echo $this->form->getInput('date'); ?></div>
          </div>
          <div class="control-group">
            <div class="control-label"><?php echo $this->form->getLabel('hits'); ?></div>
            <div class="controls"><?php echo $this->form->getInput('hits'); ?></div>
          </div>
        </div>
        <?php echo $this->loadTemplate('params'); ?>
        <div class="tab-pane" id="statistics">
          <div class="control-group">
            <div class="control-label">
            </div>
            <div class="controls">
            </div>
          </div>
          <div class="control-group">
            <div class="control-label"><a href="javascript:void(0)" onclick="ppfitemstat(<?php echo $this->form->getValue('id'); ?>,'')">Список транзакций для id: <?php echo $this->form->getValue('id'); ?></a></div>
            <div class="controls"></div>
          </div>
          <div class="control-group">
            <div class="control-label"><a href="javascript:void(0)" onclick="ppfitemstat(<?php echo $this->form->getValue('id'); ?>,'g')">График транзакций для id: <?php echo $this->form->getValue('id'); ?></a></div>
            <div class="controls"></div>
          </div>
        </div>
        <input type="hidden" name="fm" value="<?php echo $this->item->fm; ?>" />
        <input type="hidden" name="task" value="" />
        <?php echo JHtml::_('form.token'); ?> </div>
    </div>
    <div class="span2">
      <h4><?php echo JText::_('JDETAILS');?></h4>
      <hr />
      <fieldset class="form-vertical">
        <div class="control-group">
          <div class="controls"> <?php echo $this->form->getValue('title'); ?> </div>
          <div class="controls"> id: <?php echo $this->form->getValue('id'); ?> </div>
        </div>
        <div class="control-group">
          <div class="control-label"> <?php echo $this->form->getLabel('state'); ?> </div>
          <div class="controls"> <?php echo $this->form->getInput('state'); ?> </div>
        </div>
        <div class="control-group">
          <div class="control-label"> <?php echo $this->form->getLabel('access'); ?> </div>
          <div class="controls"> <?php echo $this->form->getInput('access'); ?> </div>
        </div>
        <div class="control-group">
          <div class="control-label"> <?php echo $this->form->getLabel('language'); ?> </div>
          <div class="controls"> <?php echo $this->form->getInput('language'); ?> </div>
        </div>
        <div class="control-group">
          <div class="controls"> </div>
        </div>
        <?php if ($this->item->showprice!='n'): ?>
        <div class="control-group">
          <div class="control-label"> <?php echo $this->form->getLabel('pslist'); ?> </div>
          <div class="controls"> <?php echo $this->lists['pslist']; ?> </div>
        </div>
        <?php endif;
				?>
      </fieldset>
    </div>
  </div>
</form>
