<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
defined('_JEXEC') or die;

JHtml::addIncludePath(JPATH_COMPONENT.'/helpers/html');
JHtml::_('behavior.tooltip');
JHtml::_('behavior.multiselect');
JHtml::_('formbehavior.chosen', 'select');

$user		= JFactory::getUser();
$userId		= $user->get('id');
$listOrder	= $this->escape($this->state->get('list.ordering'));
$listDirn	= $this->escape($this->state->get('list.direction'));
$canOrder	= $user->authorise('core.edit.state', 'com_payperfile.category');
$saveOrder	= $listOrder == 'a.ordering';
if ($saveOrder)
{
	$saveOrderingUrl = 'index.php?option=com_payperfile&task=payperfiles.saveOrderAjax&tmpl=component';
	JHtml::_('sortablelist.sortable', 'PPFList', 'adminForm', strtolower($listDirn), $saveOrderingUrl);
}
$sortFields = $this->getSortFields();
?>
<script type="text/javascript">
	Joomla.orderTable = function() {
		table = document.getElementById("sortTable");
		direction = document.getElementById("directionTable");
		order = table.options[table.selectedIndex].value;
		if (order != '<?php echo $listOrder; ?>') {
			dirn = 'asc';
		} else {
			dirn = direction.options[direction.selectedIndex].value;
		}
		Joomla.tableOrdering(order, dirn, '');
	}
	
		window.addEvent('domready', function() {
			$$('.qfplagin').addEvent('mouseover', function() {
				 var rng, sel;
				 if ( document.createRange ) {
					 sel = window.getSelection();
					 sel.removeAllRanges();
					 rng = document.createRange();
					 rng.selectNode( this );
					 sel.addRange( rng );
				 } else {
					 var rng = document.body.createTextRange();
					 rng.moveToElementText( this );
					 rng.select();
				 }
			});
			$$('.qfplagin').addEvent('mouseout', function() {
				this.innerHTML=this.innerHTML+'';
			});
		});
</script>
<form action="<?php echo JRoute::_('index.php?option=com_payperfile&view=payperfiles'); ?>" method="post" name="adminForm" id="adminForm">
<?php if(!empty( $this->sidebar)): ?>
	<div id="j-sidebar-container" class="span2">
		<?php echo $this->sidebar; ?>
	</div>
	<div id="j-main-container" class="span10">
<?php else : ?>
	<div id="j-main-container">
<?php endif;?>
		<div id="filter-bar" class="btn-toolbar">
			<div class="filter-search btn-group pull-left">
				<label for="filter_search" class="element-invisible"><?php echo JText::_('JSEARCH_FILTER_LABEL');?></label>
				<input type="text" name="filter_search" id="filter_search" placeholder="<?php echo JText::_('JSEARCH_FILTER_LABEL'); ?>" value="<?php echo $this->escape($this->state->get('filter.search')); ?>" title="<?php echo JText::_('JSEARCH_FILTER_LABEL'); ?>" />
			</div>
			<div class="btn-group pull-left">
				<button class="btn hasTooltip" type="submit" title="<?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?>"><i class="icon-search"></i></button>
				<button class="btn hasTooltip" type="button" title="<?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?>" onclick="document.id('filter_search').value='';this.form.submit();"><i class="icon-remove"></i></button>
			</div>
			<div class="btn-group pull-right hidden-phone">
				<label for="limit" class="element-invisible"><?php echo JText::_('JFIELD_PLG_SEARCH_SEARCHLIMIT_DESC');?></label>
				<?php echo $this->pagination->getLimitBox(); ?>
			</div>
			<div class="btn-group pull-right hidden-phone">
				<label for="directionTable" class="element-invisible"><?php echo JText::_('JFIELD_ORDERING_DESC');?></label>
				<select name="directionTable" id="directionTable" class="input-medium" onchange="Joomla.orderTable()">
					<option value=""><?php echo JText::_('JFIELD_ORDERING_DESC');?></option>
					<option value="asc" <?php if ($listDirn == 'asc') echo 'selected="selected"'; ?>><?php echo JText::_('JGLOBAL_ORDER_ASCENDING');?></option>
					<option value="desc" <?php if ($listDirn == 'desc') echo 'selected="selected"'; ?>><?php echo JText::_('JGLOBAL_ORDER_DESCENDING');?></option>
				</select>
			</div>
			<div class="btn-group pull-right">
				<label for="sortTable" class="element-invisible"><?php echo JText::_('JGLOBAL_SORT_BY');?></label>
				<select name="sortTable" id="sortTable" class="input-medium" onchange="Joomla.orderTable()">
					<option value=""><?php echo JText::_('JGLOBAL_SORT_BY');?></option>
					<?php echo JHtml::_('select.options', $sortFields, 'value', 'text', $listOrder);?>
				</select>
			</div>
		</div>
		<div class="clearfix"> </div>

	<table class="table table-striped" id="PPFList">
		<thead>
			<tr>
        <th width="1%" class="nowrap center hidden-phone">
          <?php echo JHtml::_('grid.sort', '<i class="icon-menu-2"></i>', 'a.ordering', $listDirn, $listOrder, null, 'asc', 'JGRID_HEADING_ORDERING'); ?>
        </th>
				<th width="1%" class="hidden-phone">
					<input type="checkbox" name="checkall-toggle" value="" title="<?php echo JText::_('JGLOBAL_CHECK_ALL'); ?>" onclick="Joomla.checkAll(this)" />
				</th>
				<th class="title">
					<?php echo JHtml::_('grid.sort',  'JGLOBAL_TITLE', 'a.title', $listDirn, $listOrder); ?>
				</th>
				<th width="1%" class="nowrap center">
					<?php echo JHtml::_('grid.sort',  'JSTATUS', 'a.state', $listDirn, $listOrder); ?>
				</th>
				<th width="1%">
					<?php echo JHtml::_('grid.sort',  'JCATEGORY', 'category_title', $listDirn, $listOrder); ?>
				</th>
				<th width="1%" class="nowrap hidden-phone">
					<?php echo JHtml::_('grid.sort',  'JGRID_HEADING_ACCESS', 'a.access', $listDirn, $listOrder); ?>
				</th>
        <th width="1%" class="nowrap hidden-phone">
          <?php echo JHtml::_('grid.sort', 'JGRID_HEADING_LANGUAGE', 'a.language', $listDirn, $listOrder); ?>
        </th>
			<th width="1%"  nowrap="nowrap">
				<?php echo JHTML::_('grid.sort',  'File', 'a.filename', $listDirn, $listOrder); ?>
			</th>
			<th width="1%"  nowrap="nowrap">
				<?php echo JHTML::_('grid.sort',  'Type', 'type', $listDirn, $listOrder); ?>
			</th>
			<th width="1%"  nowrap="nowrap">
				<?php echo JHTML::_('grid.sort',  'Size', 'a.size', $listDirn, $listOrder ); ?>
			</th>
			<th width="1%"  nowrap="nowrap">
				<?php echo JHTML::_('grid.sort',  'Price', 'a.price', $listDirn, $listOrder); ?>
			</th>
			<th width="1%"  nowrap="nowrap">
				<?php echo JHTML::_('grid.sort',  'Currency', 'a.currency', $listDirn, $listOrder ); ?>
			</th>
				<th width="1%" class="nowrap center hidden-phone">
					<?php echo JHtml::_('grid.sort',  'PPF_V4_SEL', 'a.hits', $listDirn, $listOrder); ?>
				</th>
			<th width="10%"  nowrap="nowrap">
				<?php echo JHTML::_('grid.sort',  'PPF_V4_FANC', 'a.fm', $listDirn, $listOrder ); ?>
			</th>
					<th width="1%" class="nowrap center hidden-phone">
						<?php echo JHtml::_('grid.sort', 'JGRID_HEADING_ID', 'a.id', $listDirn, $listOrder); ?>
					</th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="16">
				<?php echo $this->pagination->getListFooter(); ?>
			</td>
		</tr>
	</tfoot>
	<tbody>
		<?php foreach ($this->items as $i => $item) {
			$ordering	= ($listOrder == 'a.ordering');
			$item->cat_link	= JRoute::_('index.php?option=com_categories&extension=com_payperfile&task=edit&type=other&cid[]='. $item->catid);
			$canCreate	= $user->authorise('core.create',		'com_payperfile.category.'.$item->catid);
			$canEdit	= $user->authorise('core.edit',			'com_payperfile.category.'.$item->catid);
			$canCheckin	= $user->authorise('core.manage',		'com_checkin') || $item->checked_out==$user->get('id') || $item->checked_out==0;
			$canChange	= $user->authorise('core.edit.state',	'com_payperfile.category.'.$item->catid) && $canCheckin;
			?>
				<tr class="row<?php echo $i % 2; ?>" sortable-group-id="<?php echo $item->catid?>">
					<td class="order nowrap center hidden-phone">
					<?php if ($canChange) :
						$disableClassName = '';
						$disabledLabel	  = '';
						if (!$saveOrder) :
							$disabledLabel    = JText::_('JORDERINGDISABLED');
							$disableClassName = 'inactive tip-top';
						endif; ?>
						<span class="sortable-handler hasTooltip <?php echo $disableClassName?>" title="<?php echo $disabledLabel?>">
							<i class="icon-menu"></i>
						</span>
						<input type="text" style="display:none" name="order[]" size="5" value="<?php echo $item->ordering;?>" class="width-20 text-area-order " />
					<?php else : ?>
						<span class="sortable-handler inactive" >
							<i class="icon-menu"></i>
						</span>
					<?php endif; ?>
					</td>
					<td class="center hidden-phone">
						<?php echo JHtml::_('grid.id', $i, $item->id); ?>
					</td>
				<td>
					<?php if ($item->checked_out) : ?>
						<?php echo JHtml::_('jgrid.checkedout', $i, $item->editor, $item->checked_out_time, 'payperfiles.', $canCheckin); ?>
					<?php endif; ?>
					<?php if ($canEdit) : ?>
						<a href="<?php echo JRoute::_('index.php?option=com_payperfile&task=payperfile.edit&id='.(int) $item->id); ?>">
							<?php echo $this->escape($item->title); ?></a>
					<?php else : ?>
							<?php echo $this->escape($item->title); ?>
					<?php endif; ?>
						<div>
              <span class="small qfplagin"><?php echo '{payperfile id='.$item->id.'}'; ?></span>
						</div>
				</td>
				<td class="center hidden-phone">
					<?php echo JHtml::_('jgrid.published', $item->state, $i, 'payperfiles.', $canChange, 'cb'); ?>
				</td>
				<td class="center">
					<?php
					if($item->catid==0)$item->category_title='uncategorised';
					 echo $this->escape($item->category_title); ?>
				</td>
				<td class="center hidden-phone">
					<?php echo $this->escape($item->access_level); ?>
				</td>
				<td class="center hidden-phone">
					<?php echo $this->escape($item->language); ?>
				</td>
	<?php
		$folderpath = JPATH_ADMINISTRATOR.DS."components".DS.'com_payperfile'.DS.'data'.DS.$item->folder;
		if ($item->filename&&file_exists($folderpath.DS.$item->filename)){
			$size =round(filesize($folderpath.DS.$item->filename)/1024, 1).' kB';
		}else{$size ='';}
		
		$path =JPATH_ADMINISTRATOR.DS."components".DS.'com_payperfile'.DS.'fm'.DS.$item->fm.DS.$item->fm.'.xml';
		if(file_exists($path)){
		$xml = simplexml_load_file($path);
		$fmname = $xml->name;
		}else{$fmname = '';}
		?>
			<td>
				<?php
				$fileit=JFile::getName($item->filename);
				 echo '<div title="'.$item->filename.'">'.substr($fileit, 0,strrpos($fileit, '.') ).'</div>'; ?>
				<?php  if (!file_exists($folderpath.DS.$item->filename)) echo  '<div style="font-size:9px;color:red;">'.JText::_( 'not found' ).'</div>'?>
			</td>
			<td>
				<?php echo  substr($item->filename, strrpos($item->filename, '.') + 1); ?>
			</td>
			<td nowrap="nowrap">
				<?php echo $size; ?>
			</td>
			<td nowrap="nowrap">
				<?php echo $item->price; ?>
			</td>
			<td>
				<?php echo $item->currency; ?>
			</td>
            <td class="center">
                <?php echo $item->hits; ?>
            </td>
			<td>
				<?php echo JText::_($fmname); ?>
			</td>
			<td align="center">
				<?php echo $item->id; ?>
			</td>
		</tr>
		<?php
	}
	?>
	</tbody>
	</table>
	<?php  echo $this->loadTemplate('batch'); ?>

	<input type="hidden" name="task" value="" />
	<input type="hidden" name="boxchecked" value="0" />
	<input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
	<input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
	<?php echo JHTML::_( 'form.token' ); ?>
	</div>
</form>
