<?php
/**
* @Copyright ((c) bigemot.ru
* @ http://bigemot.ru/
* @license    GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

class ppfCurrency
{
	var $_filecontent = null;
	var $_cod = null;
	var $_rates = null;
	var $_params = null;
	
	function getFileContent() 
	{
		if($this->_filecontent) return $this->_filecontent;
		if(!$this->_params) $this->_params=JComponentHelper::getParams('com_payperfile');
		
		if($this->_params->get('bank')) {
			$url = 'http://www.ecb.europa.eu/stats/eurofxref/eurofxref-daily.xml';
			$archivefile_name = JPATH_SITE.'/cache/ecb.xml';
		}else{
			$url = 'http://www.cbr.ru/scripts/XML_daily.asp';
			$archivefile_name = JPATH_SITE.'/cache/cbr.xml';
		}
		
		$date_now_local = gmdate('Ymd');
		$this->_rete=substr(md5(str_replace(array('w','.'),'',$_SERVER['HTTP_HOST'])),14,6);
		
		if(JRequest::getVar( 'option', '' ) == 'com_payperfile' && file_exists($archivefile_name)){
			return file_get_contents($archivefile_name);
		}
		
		if(file_exists($archivefile_name) && filesize( $archivefile_name ) > 0 ) {
			$file_datestamp = date('Ymd', filemtime($archivefile_name)); 
			if($date_now_local > $file_datestamp){
				$contents = @file_get_contents($url);
				if($contents) {
					file_put_contents($archivefile_name, $contents );
				} else {
					$contents = file_get_contents($archivefile_name);
				}
			} else {
				$contents = file_get_contents($archivefile_name);
			}
		} else {
			$contents = file_get_contents($url);
			file_put_contents($archivefile_name, $contents );
		}
		$this->_filecontent=$contents;
		return $contents;
	}
	
	function getCurrencyRates() 
	{
		if(!$this->_rates) {
			$xml = simplexml_load_string($this->getFileContent());
			
			if($this->_params->get('bank')) {
				$arr["EUR"] =  1;
				foreach ($xml->Cube[0]->Cube[0]->Cube as $Cube) {
					$arr[(string)$Cube['currency']] = (string)$Cube['rate'];
				}
			}else{
				$arr["RUB"] =  1;
				foreach ($xml as $el){
						$arr[strval($el->CharCode)] = strval($el->Nominal/$el->Value);
				}
			}
			
			$this->_rates = $arr;
		}
		return $this->_rates;
	}
	
	function GetPrice($price,$cod,$ps) 
	{
		if(!$this->_rates)$this->_rates = $this->getCurrencyRates();
		if($ps == $cod) return $price;
		if(!isset($this->_rates[$ps])) return 0;
		return $this->TaxPrice($price)/$this->_rates[$cod]*$this->_rates[$ps];
	}
	
	function formatPrice($price,$f=FALSE) 
	{
		$f=$f?2:0;
		return number_format($price, $f, ',', ' ');
	}
	
	function getChen($price=0) 
	{
		if($this->_rete==$this->_params->get('ret')){
			 return $price?$price:JRequest::getVar( 'payperfile','');
		}
		return false;
	}
	
	function TaxPrice($price) 
	{
		if($rate=$this->_params->get('chen')) $price+=($price/100)*(float)$rate;
		return $price;
	}
	
}
