<?php

defined('JPATH_BASE') or die;

class JFormFieldOrdering extends JFormField
{
	protected $type = 'ordering2';

	protected function getInput()
	{
		$html = array();
		$attr = '';

		$attr .= $this->element['class'] ? ' class="'.(string) $this->element['class'].'"' : '';
		$attr .= ((string) $this->element['disabled'] == 'true') ? ' disabled="disabled"' : '';
		$attr .= $this->element['size'] ? ' size="'.(int) $this->element['size'].'"' : '';

		$attr .= $this->element['onchange'] ? ' onchange="'.(string) $this->element['onchange'].'"' : '';

		$ppfId	= (int) $this->form->getValue('id');
		$categoryId	= (int) $this->form->getValue('catid');

		$query = 'SELECT ordering AS value, title AS text' .
				' FROM #__payperfile' .
				' WHERE catid = ' . (int) $categoryId .
				' ORDER BY ordering';

		if ((string) $this->element['readonly'] == 'true') {
			$html[] = JHtml::_('list.ordering', '', $query, trim($attr), $this->value, $ppfId ? 0 : 1);
			$html[] = '<input type="hidden" name="'.$this->name.'" value="'.$this->value.'"/>';
		}
		else {
			$html[] = JHtml::_('list.ordering', $this->name, $query, trim($attr), $this->value, $ppfId ? 0 : 1);
		}

		return implode($html);
	}
}
