<?php
/**
* @Copyright ((c) bigemot.ru
* @ http://bigemot.ru/
* @license    GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

$app = JFactory::getApplication();
$jinput = $app->input;

// если не наш мерчант, вернемся в функциональный модуль. (обращение через компонент, не плагин)
if($option=='com_payperfile'&&$jinput->get('result')!='ps_liqpay') return;

$psParams = json_decode($ps->params, TRUE); // получим параметры платежной системы

require_once JPATH_ADMINISTRATOR.'/components/com_payperfile/helpers/payperfile.php';
require_once JPATH_ADMINISTRATOR.'/components/com_payperfile/helpers/currency.php';
$ppfCurrency = $ppfSes = new ppfCurrency;
$price = $ppfCurrency->GetPrice( $row->price, $row->currency, $psParams['curr'] );
if(!$price) JError::raiseWarning('', $psParams['curr'] .' '.JText::_('not found'));
$price *=(1 + (0.01*$ps->rate));
$price = round($price,2);

if(
	!$jinput->getVar( 'signature', NULL ) || $option!='com_payperfile'
	)
	{

		if($price)
		{
			if($jinput->get('prereq')!='pre')
			{
				if($lang->get('tag')=='en-GB')$pstitle ="LiqPay(MasterCard)";
				else $pstitle =$ps->title;
				$html .='<tr>';
				$html .= '<td>'.$pstitle.'</td>';
				$html .= '<td width="1%" nowrap="nowrap" align="right">'.$ppfCurrency->formatPrice($price, $fmParams['format']).'</td>';
				$html .= '<td width="1%">'.$psParams['curr'].'</td>';
				$html .= '<td width="1%">';

				$url = JURI::getInstance();
				$cache =  JFactory::getCache();
				if($cache->getCaching()){
					$url ->setVar('cache',rand());
				}
				$surl= $url ->toString();

				$action='/index.php?option=com_payperfile&format=raw&result=ps_liqpay&prereq=pre&liqid='.$id;
				$result_url = str_replace('&','&amp;',str_replace('&amp;','&',$surl));

				$html .= "<form class=\"payperfile\" action=\"".$action."\" method=\"POST\" >";
				$html .= "<input type=\"hidden\" name=\"ppf_email\" value=\"\">";
				if($ppfVar)$html .= "<input type=\"hidden\" name=\"ppf_var\" value=\"\">";
				$html .= "<input type=\"hidden\" name=\"psid\" value=\"".$ps->id."\">";
				$html .= "<input type=\"hidden\" name=\"result_url\" value=\"".$result_url."\">";
				$html .= "<input type=\"button\" value=\"".JText::_($fmParams['btn1'])."\" onclick=\"ppfWin(this.form,".(int)$fmParams['target'].")\" class=\"ppf_btn\"/>";
				$html .= "</form>";
				$html .='</td></tr>';
			}
			else{
				if($ps->id!=$jinput->getInt('psid')) return;

				$ppf_email=($ppfE=$jinput->getVar( 'ppf_email', '' ))?"&amp;p_e=".$ppfE:'';
				$ppf_var=($ppfVar)?"&amp;p_v=".$jinput->getVar( 'ppf_var', '' ):'';
				$ppf_user = ($user->get('id'))?"&amp;p_u=".$user->get('id'):'';
				$ps_id = "&amp;p_s=".$ps->id;

				if($psParams['curr']=='RUB') $psParams['curr']='RUR';

				$xml="<request>
					<version>1.2</version>
					<result_url>".$_POST['result_url']."</result_url>
					<server_url>".JURI::base()."/index.php?option=com_payperfile&amp;format=raw&amp;result=ps_liqpay&amp;liqid=".
					$id.$ppf_email.$ppf_var.$ppf_user.$ps_id."</server_url>
					<merchant_id>".$psParams['purse']."</merchant_id>
					<order_id>ORDER_".time().'*'.md5($session->getID())."</order_id>
					<amount>".$price."</amount>
					<currency>".$psParams['curr']."</currency>
					<description>".$fmParams['desc']."</description>
					<default_phone></default_phone>
					<pay_way>card, liqpay</pay_way>";
					if($lang->get('tag')=='en-GB')$xml .="<language>EN</language>";
					else $xml .="<language>RU</language>";
					$xml .="</request>";

				$signature=PayperfileHelper::encode(base64_decode($psParams['secret_key']));
				$xml_encoded = base64_encode($xml);
				$lqsignature = base64_encode(sha1($signature.$xml.$signature,1));

				$html  = "<form name=\"payperfile\" action=\"https://www.liqpay.ua/?do=clickNbuy\" method=\"POST\" >";
				$html .= "<input type='hidden' name='operation_xml' value='$xml_encoded' />";
				$html .= "<input type='hidden' name='signature' value='$lqsignature' />";
				$html .= "</form>";
				$html .= "<script type=\"text/javascript\">document.forms.payperfile.submit();</script>";

				echo $html;
				die();
		}
	}
}
elseif($jinput->getVar( 'operation_xml', FALSE))
{
	if($jinput->getInt( 'p_s', NULL)!=$ps->id) return; // это не та платежная система (случай, если вы создали несколько ПС с этим мерчантом), вернемся в функциональный модуль и найдем свою.

	$xml_decoded=base64_decode($_POST['operation_xml']);
	$xml = simplexml_load_string($xml_decoded);

	if($price==$xml->amount)
	{
		$signature=PayperfileHelper::encode(base64_decode($psParams['secret_key']));
		$sign=base64_encode(sha1($signature.$xml_decoded.$signature,1));
		if($sign!==$_POST['signature']) return;

		if($xml->status=='success')
		{
			$registry = new JRegistry();
			$registry->loadObject($xml);
			$ss=explode('*', $xml->order_id);
			$ss3 = (bool)preg_match("/[0-9a-f]{32}/i", $ss[1]);
			if(!$ss3) return; // sql фикс
			$mail=$jinput->getVar( 'p_e', '' );
			$registry->set('ppf_email',$mail);
			$ses = $ppfSes->getChen($ss[1]);
			$ppf_user=$jinput->getVar( 'p_u', '' );
			$ppf_var=$jinput->getVar( 'p_v', '' );
			if($ppf_var)$registry->set('ppf_var',$ppf_var);

			if($ppfVar){
				// обработка дополнительных параметров
			}

			$fields = array(
				'session_id' => $ses,
				'date' => time(),
				'user' => (int)$ppf_user,
				'currency' => str_replace('RUR','RUB',$xml->currency),
				'amount' => $price,
				'params' => $registry->toString(),
				'ps' => $ps->title,
				'fm' => $row->fm,
				'fileid' => (int)$id
			);

			$v_key=	$v_value='';
			foreach($fields as $key=>$value){
				$v_key.=",$key";
				$v_value.=",'$value'";
			}
			$v_key=substr($v_key, 1);
			$v_value=substr($v_value, 1);

			$db->setQuery("INSERT INTO `#__payperfile_stat` ($v_key) VALUES ($v_value)");
			$db->query();

			$db->setQuery("UPDATE `#__payperfile` SET hits = ( hits + 1 ) WHERE id = ".(int)$id);
			$db->query();

			if($maySend && $ses && $mail) {
				require_once JPATH_ADMINISTRATOR.'/components/com_payperfile/helpers/ppf_email.php';
				$ppf_email = new PayperfileMail;
				$ppf_email->send($row, $mail, $mailhtml, $attachment);
			}

			 echo "YES";
			 die();
		}
	}
}
