<?php
/**
* @Copyright ((c) bigemot.ru
* @ http://bigemot.ru/
* @license    GNU/GPL
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

$app = JFactory::getApplication();
$jinput = $app->input;

// если не наш мерчант, вернемся в функциональный модуль. (обращение через компонент, не плагин)
if($option=='com_payperfile'&&$jinput->get('result')!='ps_vm') return;

$psParams = json_decode($ps->params, TRUE); // получим параметры платежной системы

// Вспомогательный массив, поможет нам по первому символу кошелька вывести код валюты
$WMps = array('Z'=>'USD', 'R'=>'RUB', 'U'=>'UAH', 'E'=>'EUR', 'D'=>'USD');

require_once JPATH_ADMINISTRATOR.'/components/com_payperfile/helpers/payperfile.php';
require_once JPATH_ADMINISTRATOR.'/components/com_payperfile/helpers/currency.php';
$ppfCurrency = $ppfSes = new ppfCurrency;
$price = $ppfCurrency->GetPrice( $row->price, $row->currency, $WMps[$psParams['purse']{0}] );
$price *=(1 + (0.01*$ps->rate));
$price = round($price,2);

if(
	!$jinput->get( 'LMI_PAYMENT_NO', NULL ) || $option!='com_payperfile'
	)
{
	if($price)
	{
		$html .='<tr>';
		$html .= '<td align="right">'.$ps->title.'</td>';
		$html .= '<td width="1%" nowrap="nowrap" align="right">'.$ppfCurrency->formatPrice($price, $fmParams['format']).'</td>';
		$html .= '<td width="1%">'.$WMps[$psParams['purse']{0}].'</td>';
		$html .= '<td width="1%">';
		
		$url = JURI::getInstance();
		$cache =  JFactory::getCache();
		if($cache->getCaching()){
			$url ->setVar('cache',rand()); // обход кэширования, если включено
		}
		$surl= $url ->toString(); // SUCCESS_URL
		
		$url ->setVar('fail','fail');
		$furl= $url ->toString(); // FAIL_URL
		
		$action='https://merchant.webmoney.ru/lmi/payment.asp';
		
		$html .= "<form class=\"payperfile\" action=\"".$action."\" method=\"POST\" >";
		$html .= "<input type=\"hidden\" name=\"LMI_PAYMENT_AMOUNT\" value=\"".round($price,$fmParams['format']?2:0)."\">";
		$html .= "<input type=\"hidden\" name=\"LMI_PAYEE_PURSE\" value=\"".$psParams['purse']."\">";
		$html .= "<input type=\"hidden\" name=\"LMI_PAYMENT_NO\" value=\"".time()."\">";
		$html .= "<input type=\"hidden\" name=\"LMI_PAYMENT_DESC_BASE64\" value=\"".base64_encode($fmParams['desc'])."\">";
		$html .= "<input type=\"hidden\" name=\"LMI_FAIL_URL\" value=\"".$furl."\">";
		$html .= "<input type=\"hidden\" name=\"LMI_SUCCESS_URL\" value=\"".$surl."\">";
		$html .= "<input type=\"hidden\" name=\"payperfile\" value=\"".md5($session->getID())."\">";
		$html .= "<input type=\"hidden\" name=\"fileid\" value=\"".$id."\">";
		$html .= "<input type=\"hidden\" name=\"ppf_user\" value=\"".$user->get('id')."\">";
		$html .= "<input type=\"hidden\" name=\"ppf_email\" value=\"\">";
		$html .= "<input type=\"hidden\" name=\"psid\" value=\"".$ps->id."\">";
		if($ppfVar)$html .= "<input type=\"hidden\" name=\"ppf_var\" value=\"\">";
		$html .= "<input type=\"button\" value=\"".JText::_($fmParams['btn1'])."\" onclick=\"ppfWin(this.form,".(int)$fmParams['target'].")\" class=\"ppf_btn\"/>";
		$html .= "</form>";
		$html .='</td></tr>';
	}
} 
else	{ // обработаем ответы сервера webmoney

	// поскольку в кнопке может находиться несколько экземпляров этого мерчанта, проверим, что это искомая платежная система. В противном случае вернем процесс в функциональный модуль.
	if($ps->id!=$jinput->getInt('psid')) return;
	
	// предварительный запрос, до проведения транзакции
	if($_POST['LMI_PREREQUEST']==1&&$jinput->get('mod','')=='res')
	{
	  if($row->filename) {
			if(!file_exists(JPATH_ADMINISTRATOR.'/components/com_payperfile/data/'.$row->folder.'/'.$row->filename)){
				echo "ERR: FILE NOT FAUND";
				exit;
			}
	  }
	  if($_POST['LMI_PAYEE_PURSE']!=$psParams['purse']) {
			echo "ERR: INCORRECT PAYEE PURSE ".$_POST['LMI_PAYEE_PURSE'];
			exit;
	  }
		if(round($price,2)!=round($_POST['LMI_PAYMENT_AMOUNT'],2)) {
		  echo "ERR: INCORRECT AMOUNT ".$_POST['LMI_PAYMENT_AMOUNT'];
			exit;
		}
	  echo "YES"; // разрешаем перевод денег
		exit;
		
	}
	elseif($jinput->get('mod','')=='res'){ // обработка уведомления, после транзакции
	
	// проверка, что это настоящий ответ сервера webmoney, не фишинг
	  $common_string = $_POST['LMI_PAYEE_PURSE'].$_POST['LMI_PAYMENT_AMOUNT'].$_POST['LMI_PAYMENT_NO'].
		 $_POST['LMI_MODE'].$_POST['LMI_SYS_INVS_NO'].$_POST['LMI_SYS_TRANS_NO'].
		 $_POST['LMI_SYS_TRANS_DATE'].PayperfileHelper::encode(base64_decode($psParams['secret_key'])).$_POST['LMI_PAYER_PURSE'].$_POST['LMI_PAYER_WM'];
		 if($psParams['hash']=='md5') $hash = strtoupper(md5($common_string));
		 if($psParams['hash']=='sha256') $hash = strtoupper(hash('sha256', $common_string));
		 
	  if($hash!==strtoupper($_POST['LMI_HASH'])) exit;

		// если все в порядке, запишем данные платежа в базу сайта.

		$registry = new JRegistry();
		unset($_POST['LMI_PAYMENT_DESC']); // баг с кириллицей
		$registry->loadArray($_POST);
		$mail=$jinput->getVar( 'ppf_email', '' );
	  $session_id=$ppfSes->getChen();
		
		if($ppfVar){
			// обработаем дополнительные параметры, если используется
		}
		
		$ss3 = (bool)preg_match("/[0-9a-f]{32}/i", $session_id);
		if(!$ss3) exit; // фикс  sql уязвимости
		
		$fields = array(
			'session_id' => $session_id, 
			'date' => time(),
			'user' => $jinput->getInt( 'ppf_user',NULL), 
			'currency' => $WMps[$psParams['purse']{0}] , 
			'amount' => $price,
			'params' => $registry->toString(), 
			'ps' => $ps->title, 
			'fm' => $row->fm, 
			'fileid' => (int)$id
		);

		$v_key=	$v_value='';
		foreach($fields as $key=>$value){
			$v_key.=",$key";
			$v_value.=",'$value'";
		}
		$v_key=substr($v_key, 1);
		$v_value=substr($v_value, 1);

		$db->setQuery("INSERT INTO `#__payperfile_stat` ($v_key) VALUES ($v_value)");
		$db->query();
		
		$db->setQuery("UPDATE `#__payperfile` SET hits = ( hits + 1 ) WHERE id = ".(int)$id);
		$db->query();
		
		// отправим письмо, если нужно
		if($maySend && $mail && $session_id) {
			require_once JPATH_ADMINISTRATOR.'/components/com_payperfile/helpers/ppf_email.php';
			$ppf_email = new PayperfileMail;
			$ppf_email->send($row, $mail, $mailhtml, $attachment);
		}
		
		echo "YES";	
		die();
	}
}
