CREATE TABLE IF NOT EXISTS `#__payperfile` (
  `id` int(11) NOT NULL auto_increment,
  `catid` int(11) NOT NULL default '0',
  `checked_out` int(11) NOT NULL default '0',
  `checked_out_time` datetime,
  `state` tinyint(1)  default NULL ,
  `title` varchar(128) NOT NULL default '',
  `filename` varchar(128) NOT NULL default '',
  `folder` varchar(128) NOT NULL default '',
  `ordering` int(11) NOT NULL default '0',
  `access` int(11) NOT NULL default '1',
  `currency` char(7) NOT NULL default '',
  `price` float(18) NOT NULL default '0',
  `fm` varchar(50) NOT NULL default '',
  `date` datetime,
  `description` text,
  `language` char(7) NOT NULL default '',
  `hits` int(11) NOT NULL default '0',
  `pslist` text,
  `params` text,
  PRIMARY KEY  (`id`)
);
CREATE TABLE IF NOT EXISTS `#__payperfile_ps` (
  `id` int(11) NOT NULL auto_increment,
  `checked_out` int(11) NOT NULL default '0',
  `checked_out_time` datetime,
  `state` tinyint(1) NOT NULL default '1',
  `title` varchar(128) NOT NULL default '',
  `ordering` int(11) NOT NULL default '0',
  `access` int(11) NOT NULL default '1',
	`ps` varchar(50) NOT NULL default '',
  `date` datetime,
  `language` char(7) NOT NULL default '',
  `rate` float(4) NOT NULL default '0',
  `params` text,
  PRIMARY KEY  (`id`)
);
CREATE TABLE IF NOT EXISTS `#__payperfile_stat` (
  `id` int(11) NOT NULL auto_increment,
  `amount` float(8,2) NOT NULL default '0',
  `date` int(11) NOT NULL default '0',
  `filename` varchar(128) NOT NULL default '',
  `email` varchar(128) NOT NULL default '',
  `currency` char(7) NOT NULL default '',
  `fileid` int(11) NOT NULL default '0',
  `session_id` varchar(128) NOT NULL default '',
  `ip` varchar(128) NOT NULL default '',
  `ps` varchar(50) NOT NULL default '',
  `fm` varchar(50) NOT NULL default '',
  `state` tinyint(1) NOT NULL default '1',
  `access` int(11) NOT NULL default '1',
  `user` int(11)  default NULL ,
  `params` text,
  PRIMARY KEY  (`id`)
);
