<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

JHtml::addIncludePath(JPATH_COMPONENT.'/helpers/html');
JHtml::_('behavior.tooltip');
JHtml::_('behavior.formvalidation');
JHtml::_('formbehavior.chosen', 'select');
?>

<script type="text/javascript">
	Joomla.submitbutton = function(task)
	{
		if (task == 'paysystem.cancel' || document.formvalidator.isValid(document.id('paysystem-form'))) {
			Joomla.submitform(task, document.getElementById('paysystem-form'));
		}
		else {
			alert('<?php echo $this->escape(JText::_('JGLOBAL_VALIDATION_FORM_FAILED'));?>');
		}
	}
</script>

<h3><?php echo $this->item->title ?></h3>
<form action="<?php echo JRoute::_('index.php?option=com_payperfile&view=paysystem&layout=edit&id='.(int) $this->item->id); ?>" method="post" name="adminForm" id="paysystem-form" class="form-validate" >

<div class="row-fluid">

	<div class="span10 form-horizontal">
		<ul class="nav nav-tabs">
			<li class="active"><a href="#details" data-toggle="tab"><?php echo empty($this->item->id) ? JText::_('COM_PAYPERFILE_NEW') : JText::sprintf('PPF_V3_EDIT', $this->item->id); ?></a></li>
		</ul>
		<div class="tab-content">
			<div class="tab-pane active" id="details">
				<div class="control-group">
					<div class="control-label"><?php echo $this->form->getLabel('title'); ?></div>
					<div class="controls"><?php echo $this->form->getInput('title'); ?></div>
				</div>
				<div class="control-group">
					<div class="control-label"><?php echo $this->form->getLabel('rate'); ?></div>
					<div class="controls"><?php echo $this->form->getInput('rate'); ?></div>
				</div>
			<?php echo $this->loadTemplate('params'); ?>
			</div>
      <div class="control-group">
        <div class="control-label"><?php echo $this->form->getLabel('ordering'); ?></div>
        <div class="controls"><?php echo $this->form->getInput('ordering'); ?></div>
      </div>
      <input type="hidden" name="jform[ps]" id="jform_ps" value="<?php echo $this->item->ps; ?>" />
			<input type="hidden" name="task" value="" />
			<?php echo JHtml::_('form.token'); ?>
		</div>
		</div>
    
		<div class="span2">
			<h4><?php echo JText::_('JDETAILS');?></h4>
			<hr />
			<fieldset class="form-vertical">
				<div class="control-group">
					<div class="controls">
						<?php echo $this->form->getValue('title'); ?>
					</div>
					<div class="controls">
						id: <?php echo $this->form->getValue('id'); ?>
					</div>
				</div>
				<div class="control-group">
					<div class="control-label">
						<?php echo $this->form->getLabel('state'); ?>
					</div>
					<div class="controls">
						<?php echo $this->form->getInput('state'); ?>
					</div>
				</div>
				<div class="control-group">
					<div class="control-label">
						<?php echo $this->form->getLabel('access'); ?>
					</div>
					<div class="controls">
						<?php echo $this->form->getInput('access'); ?>
					</div>
				</div>
				<div class="control-group">
					<div class="control-label">
						<?php echo $this->form->getLabel('language'); ?>
					</div>
					<div class="controls">
						<?php echo $this->form->getInput('language'); ?>
					</div>
				</div>
			</fieldset>
      </div>
		</div>
    </br></br>
	<fieldset class="adminform">
		<legend><?php echo JText::_( 'PPF_V5_SETT' ); ?></legend>

		<table class="admintable">
		<tr>
			<td>
				<?php echo JText::_( 'PPF_SETTING' ).' <a href="'.$this->item->psurl.'" target="blank"> '.$this->item->psurl.'</a>';?></br>
				<?php
				if(file_exists(JPATH_ADMINISTRATOR.DS."components".DS.'com_payperfile'.DS.'ps'.DS.$this->item->ps.DS.'sett.jpg'))
				 echo JText::_( 'PPF_EX' ).' <a href="/administrator/components/com_payperfile/ps/'.$this->item->ps.'/sett.jpg" target="blank"> '.JText::_( 'PPF_VIEW' ).'</a>';?>
			</td>
		</tr>
		<tr>
			<td style="color:#666666">
				<?php 
				if($this->item->resurl)
				echo "<b>Result URL:</b></br> http://".$_SERVER['HTTP_HOST'].'/index.php?option=com_payperfile&format=raw&result='.$this->item->resurl.'</br>';
				if($this->item->sucurl)
				echo "<b>Success URL:</b></br> http://".$_SERVER['HTTP_HOST'].'/index.php?option=com_payperfile&format=raw&result='.$this->item->sucurl.'</br>';
				if($this->item->failurl)
				echo "<b>Fail URL:</b></br> http://".$_SERVER['HTTP_HOST'].'/index.php?option=com_payperfile&format=raw&result='.$this->item->failurl.'</br>';
				?>
			</td>
		</tr>
		<tr>
			<td style=""></br></br>
     <?php if($this->item->desc){
			 $desc=explode(',',$this->item->desc);$i=1;
			 foreach($desc as $des){
				 echo $i.'. '.JText::_( 'PPF_PS_DESC_'.$des).'<br />';$i++;
			 }
		 }?>
			</td>
		</tr>
		</table>
	</fieldset>
</form>


