<?php
/**
* @package		Joomla
* @Copyright ((c) bigemot.ru
* @license    GNU/GPL
*/
defined('_JEXEC') or die;

JHtml::addIncludePath(JPATH_COMPONENT.'/helpers/html');
JHtml::_('behavior.tooltip');
JHtml::_('behavior.multiselect');
JHtml::_('formbehavior.chosen', 'select');
JHtml::_('behavior.calendar');

$user		= JFactory::getUser();
$userId		= $user->get('id');
$listOrder	= $this->escape($this->state->get('list.ordering'));
$listDirn	= $this->escape($this->state->get('list.direction'));
$canOrder	= $user->authorise('core.edit.state', 'com_payperfile.category');
$saveOrder	= $listOrder == 'a.ordering';
$sortFields = $this->getSortFields();
$fileid=$this->gfileid?'&fileid='.$this->gfileid:'';

?>
<script type="text/javascript">
	Joomla.orderTable = function() {
		table = document.getElementById("sortTable");
		direction = document.getElementById("directionTable");
		order = table.options[table.selectedIndex].value;
		if (order != '<?php echo $listOrder; ?>') {
			dirn = 'asc';
		} else {
			dirn = direction.options[direction.selectedIndex].value;
		}
		Joomla.tableOrdering(order, dirn, '');
	}
</script>

<form action="<?php echo JRoute::_('index.php?option=com_payperfile&view=statistics'); ?>" method="post" name="adminForm" id="adminForm">
  <?php if(!empty( $this->sidebar)): ?>
  <div id="j-sidebar-container" class="span2"> <?php echo $this->sidebar; ?> </div>
  <div id="j-main-container" class="span10">
  <?php else : ?>
  <div id="j-main-container">
    <?php endif;?>
    <ul class="nav nav-tabs">
      <li class="active"> <a href="javascript:void(0)"><?php echo JText::_('PPF_V2_LIST');?></a> </li>
      <li> <a href="<?php echo JRoute::_('index.php?option=com_payperfile&view=charts'.$fileid); ?>"><?php echo JText::_('PPF_V7_GTRAN');?></a> </li>
    </ul>
    <div id="filter-bar" class="btn-toolbar">
      <div class="filter-search btn-group pull-left">
        <label for="filter_search" class="element-invisible"><?php echo JText::_('JSEARCH_FILTER_LABEL');?></label>
        <input type="text" name="filter_search" id="filter_search" placeholder="<?php echo JText::_('JSEARCH_FILTER_LABEL'); ?>" value="<?php echo $this->escape($this->state->get('filter.search')); ?>" title="<?php echo JText::_('JSEARCH_FILTER_LABEL'); ?>" />
      </div>
      <div class="btn-group pull-left">
        <button class="btn hasTooltip" type="submit" title="<?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?>"><i class="icon-search"></i></button>
        <button class="btn hasTooltip" type="button" title="<?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?>" onclick="document.id('filter_search').value='';this.form.submit();"><i class="icon-remove"></i></button>
      </div>
      <div class="btn-group pull-left ppf_calendar">
        <?php 
      echo JHTML::_('calendar', $this->escape($this->state->get('filter.min')), 'filter_min', 'filter_min', '%Y-%m-%d', array('class'=>'inputbox', 'size'=>'25',  'maxlength'=>'19')); 
      echo JHTML::_('calendar', $this->escape($this->state->get('filter.max')), 'filter_max', 'filter_max', '%Y-%m-%d', array('class'=>'inputbox', 'size'=>'25',  'maxlength'=>'19')); 
      ?>
      </div>
      <button class="btn hasTooltip" type="submit" title="<?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?>"><i class="icon-search"></i></button>
      <button class="btn hasTooltip" type="button" title="<?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?>" onclick="document.id('filter_min').value='';document.id('filter_max').value='';this.form.submit();"><i class="icon-remove"></i></button>
      <div class="btn-group pull-right hidden-phone">
        <label for="limit" class="element-invisible"><?php echo JText::_('JFIELD_PLG_SEARCH_SEARCHLIMIT_DESC');?></label>
        <?php echo $this->pagination->getLimitBox(); ?> </div>
      <div class="btn-group pull-right hidden-phone">
        <label for="directionTable" class="element-invisible"><?php echo JText::_('JFIELD_ORDERING_DESC');?></label>
        <select name="directionTable" id="directionTable" class="input-medium" onchange="Joomla.orderTable()">
          <option value="asc" <?php if ($listDirn == 'asc') echo 'selected="selected"'; ?>><?php echo JText::_('JGLOBAL_ORDER_ASCENDING');?></option>
          <option value="desc" <?php if ($listDirn == 'desc') echo 'selected="selected"'; ?>><?php echo JText::_('JGLOBAL_ORDER_DESCENDING');?></option>
        </select>
      </div>
      <div class="btn-group pull-right">
        <label for="sortTable" class="element-invisible"><?php echo JText::_('JGLOBAL_SORT_BY');?></label>
        <select name="sortTable" id="sortTable" class="input-small" onchange="Joomla.orderTable()">
          <option value=""><?php echo JText::_('JGLOBAL_SORT_BY');?></option>
          <?php echo JHtml::_('select.options', $sortFields, 'value', 'text', $listOrder);?>
        </select>
      </div>
    </div>
    <div class="clearfix"> </div>
    <table class="table table-striped" id="PPFList">
      <thead>
        <tr>
          <th width="10px" class="hidden-phone"> # </th>
          <th width="10px" class="hidden-phone"> <input type="checkbox" name="checkall-toggle" value="" title="<?php echo JText::_('JGLOBAL_CHECK_ALL'); ?>" onclick="Joomla.checkAll(this)" />
          </th>
          <th nowrap="nowrap"> <?php echo JHTML::_('grid.sort',  'JDATE', 'a.date', $listDirn, $listOrder ); ?> </th>
          <th nowrap="nowrap"> <?php echo JHtmL::_('grid.sort',  'JSTATUS', 'a.state', $listDirn, $listOrder); ?> </th>
          <th nowrap="nowrap"> <?php echo JHTML::_('grid.sort',  'JGLOBAL_TITLE', 'a.fileid', $listDirn, $listOrder ); ?> </th>
          <th nowrap="nowrap"> <?php echo JHTML::_('grid.sort',  'FM', 'a.fm', $listDirn, $listOrder ); ?> </th>
          <th nowrap="nowrap"> <?php echo JHTML::_('grid.sort',  'PS', 'a.ps', $listDirn, $listOrder ); ?> </th>
          <th nowrap="nowrap"> <?php echo JHTML::_('grid.sort',  'PPF_AMMAUNT2', 'a.amount', $listDirn, $listOrder  ); ?> </th>
          <th nowrap="nowrap"> <?php echo JHTML::_('grid.sort',  'CURRENCY', 'a.currency', $listDirn, $listOrder ); ?> </th>
          <th nowrap="nowrap"> <?php echo JHTML::_('grid.sort',  'PPF_USER', 'a.user', $listDirn, $listOrder ); ?> </th>
          <th nowrap="nowrap"> <?php echo JHTML::_('grid.sort',  'IP', 'a.ip', $listDirn, $listOrder ); ?> </th>
          <th nowrap="nowrap"> <?php echo JHTML::_('grid.sort',  'ID', 'a.id', $listDirn, $listOrder ); ?> </th>
        </tr>
      </thead>
      <tfoot>
        <tr>
          <td colspan="12"><?php echo $this->pagination->getListFooter(); ?></td>
        </tr>
      </tfoot>
      <tbody>
        <?php 
			$canChange	= $user->authorise('core.manage',		'com_checkin');
				foreach ($this->items as $i => $item) 
		{
		?>
        <tr class="row<?php echo $i % 2; ?>">
          <td><?php echo $this->state->get('list.start')+$i+1; ?></td>
          <td class="center"><?php echo JHtml::_('grid.id', $i, $item->id); ?></td>
          <td><a href="javascript:void(0)" onclick="ppfParams(<?php echo $item->id ?>)"><?php echo $this->escape(date("d M Y H:i:s",$item->date));?></a></td>
          <td class="center hidden-phone"><?php echo JHtml::_('jgrid.published', $item->state, $i, 'statistics.', $canChange, 'cb'); ?></td>
          <td align="center"><?php 
					if($item->title) echo $item->title;
					else echo $item->fileid;
					 ?></td>
          <td><?php 
					$path =JPATH_ADMINISTRATOR.DS."components".DS.'com_payperfile'.DS.'fm'.DS.$item->fm.DS.$item->fm.'.xml';
					$xml = simplexml_load_file($path);
					$fm = $xml->name;
					?>
            <span class="hasTip" title="<?php echo $fm;?>"> <?php echo str_replace('fm_','',$item->fm); ?> </span></td>
          <td><?php echo $item->ps; ?></td>
          <td><?php echo $item->amount;?></td>
          <td><?php echo $item->currency; ?></td>
          <td><?php echo $item->username; ?></td>
          <td><?php echo $item->ip; ?></td>
          <td><?php echo $item->id; ?></td>
        </tr>
        <?php
    }
    ?>
      </tbody>
    </table>
  </div>
  <input type="hidden" name="task" value="" />
  <input type="hidden" name="fileid" value="<?php echo $fileid; ?>" />
  <input type="hidden" name="boxchecked" value="0" />
  <input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
  <input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
  <?php echo JHTML::_( 'form.token' ); ?>
</form>
