<?php 
/**
* PayPerFile Plugin for Joomla!
* @Copyright ((c) bigemot.ru
* @ All rights reserved
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @ http://bigemot.ru/
* @version 1.00.1
**/
defined('_JEXEC') or die('Direct Access to this location is not allowed.');

class plgContentPayPerFile extends JPlugin
{
	public function onContentPrepare($context, &$row, &$params, $page = 0)
	{
		// Don't run this plugin when the content is being indexed
		if ($context == 'com_finder.indexer') {
			return true;
		}

		if ( JString::strpos( $row->text, '{payperfile id' ) === false ) {
			return true;
		}
		require_once(JPATH_ADMINISTRATOR."/components/com_payperfile/helpers/integrator.php");
		$pattern = '/{payperfile\s*.*?}/i';
		if ( !$this->params->def( 'enabled', 1 ) ) {
			$row->text = preg_replace( $pattern, '', $row->text );
			return true;
		}
		preg_match_all( $pattern, $row->text, $matches );
		$count = count( $matches[0] );
		if ( $count ) {
			$this->plgContentReplacePayPerFile( $row, $matches, $count, $pattern );
			

		}
	}
	
	function plgContentReplacePayPerFile(&$row, &$matches, $count, $pattern) {
		for ( $i=0; $i < $count; $i++ ){
			$id = trim(preg_replace("/.*?id.*?=/i", "", trim($matches[0][$i])));
			$id = str_replace( '}', '', $id );
			$btn	= $this->plgContentLoadPayPerFile( $id);
			$row->text 	= str_replace($matches[0][$i], $btn, $row->text );
		}
	}
	
	function plgContentLoadPayPerFile($id){
	
		$contents = new payperfileButton($id);
		return $contents->getHTML();
	}
}
